
#include <TimerOne.h>

// --- constantes des broches ---

const int Voie_0 = 1; //declaration constante de broche analogique
const int Voie_1 = 4; //declaration constante de broche analogique
const int Voie_2 = 7; //declaration constante de broche analogique
const int Voie_3 = 4; // LED
const int Voie_4 = 2; // buzzer


// --- Déclaration des variables globales ---
int mesure_x = 0;// Variable pour acquisition résultat brut de conversion analogique numérique
int mesure_y = 0;
int mesure_z = 0;
int ticks = 0;
int debut = 0;
boolean demarre = false;

// --- Initialisation des fonctionnalités utilisées ---

//**************** FONCTION SETUP = Code d'initialisation *****
// La fonction setup() est exécutée en premier et 1 seule fois, au démarrage du programme

void setup() // debut de la fonction setup()
{
	// --- ici instructions à exécuter au démarrage ---

	Serial.begin(115200); // initialise connexion série à 115200 bauds
	// IMPORTANT : régler le terminal côté PC avec la même valeur de transmission
	pinMode(Voie_0, INPUT);
	pinMode(Voie_1, INPUT);
	pinMode(Voie_2, INPUT);
	pinMode(Voie_3, OUTPUT);
	pinMode(Voie_4, OUTPUT);
	Timer1.initialize(1000000);
} 

void Comptetemps(void)
{
  	if (ticks == 30)
  	{
	    	digitalWrite(Voie_3,LOW);
	    	tone(Voie_4,440,4000);
	    	Serial.write("Ok fini");
	    	Timer1.detachInterrupt();
	   	ticks = 0;
  	}
  	else
  	{
  		ticks++; 
  		digitalWrite(Voie_3,HIGH);
  		Serial.println(ticks);
  	} 
}

void loop()  // debut de la fonction loop()
{
	// --- ici instructions à exécuter par le programme principal ---

	// acquisition conversion analogique-numerique (CAN) sur la voie analogique
	int mesure_a=analogRead(Voie_0);
	int mesure_b=analogRead(Voie_1);
	int mesure_c=analogRead(Voie_2);
	delay(1000);

	int mesure_a2=analogRead(Voie_0);
	int mesure_b2=analogRead(Voie_1);
	int mesure_c2=analogRead(Voie_2);

	// affiche valeur numerique entière ou à virgule au format décimal

	// affiche valeur numerique entière ou à virgule au format décimal
	Serial.print("a =");
	Serial.println(mesure_a);
	Serial.print("b=");
	Serial.println(mesure_b);
	Serial.print("c=");
	Serial.println(mesure_c);

	Serial.print("a2 =");
	Serial.println(mesure_a - mesure_a2);
	Serial.print("b2=");
	Serial.println(mesure_b - mesure_b2);
	Serial.print("c2=");
	Serial.println(mesure_c - mesure_c2);

	if ((abs(mesure_a - mesure_a2) > 100) || (abs(mesure_b - mesure_b2) > 100) || (abs(mesure_c - mesure_c2) > 100))
	{
  		demarre = true;
  		Serial.write("je suis passe");
  		if (ticks == 0)
  		{
  			Timer1.attachInterrupt(Comptetemps);
  		}
  		delay(1000);
	}
	else 
	{
  		demarre = false;
  		if (ticks != 0)
  		{
  			digitalWrite(Voie_3,LOW);
  			if (abs(mesure_a - mesure_a2) < 70) 
  				tone(Voie_4,750,500);
  		}
  		Serial.write("je suis passe2");
  		delay(1000);
	}
} 
