
#include <TimerOne.h>
#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/interrupt.h>
#include <MsTimer2.h>
#include <avr/power.h>
#include <avr/wdt.h>
#include <avr/sleep.h>

// --- constantes des broches ---
const int Voie_0=A1; //declaration constante de broche analogique
const int Voie_1=A4; //declaration constante de broche analogique
const int Voie_2=A7; //declaration constante de broche analogique
const int Voie_3 =4;
const int Voie_4 =2;

// --- Déclaration des variables globales ---
int mesure_x=0;// Variable pour acquisition résultat brut de conversion analogique numérique
int mesure_y=0;
int mesure_z=0;
int ticks = 0;
int debut = 0;
int change = 0;

// --- Initialisation des fonctionnalités utilisées ---

//**************** FONCTION SETUP = Code d'initialisation *****
// La fonction setup() est exécutée en premier et 1 seule fois, au démarrage du programme
void setup()  // debut de la fonction setup()
{
	// --- ici instructions à exécuter au démarrage ---
	Serial.begin(9600); // initialise connexion série à 115200 bauds

	// IMPORTANT : régler le terminal côté PC avec la même valeur de transmission
	pinMode(Voie_0, INPUT);
	pinMode(Voie_1, INPUT);
	pinMode(Voie_2, INPUT);
	pinMode(Voie_3, OUTPUT);
	pinMode(Voie_4, OUTPUT);
	Timer1.initialize(1000000);

	/* Clear the reset flag. */
	MCUSR &= ~(1<<WDRF);
	 
	/* In order to change WDE or the prescaler, we need to
	* set WDCE (This will allow updates for 4 clock cycles).
	*/
	WDTCSR |= (1<<WDCE) | (1<<WDE);

	/* set new watchdog timeout prescaler value */
	//WDTCSR = 1<<WDP0 | 1<<WDP3; /* 8.0 seconds */
	WDTCSR =  0b01000000 | 0b100000 ;
	 
	/* Enable the WD interrupt (note no reset). */
	WDTCSR |= _BV(WDIE);

	//MsTimer2::set(3000, flash); // 500ms period

	int change =0;
 	sleep_enable();  
}

ISR(WDT_vect)
{
}

void Comptetemps(void)
{
  	if (ticks == 15)
  	{
    		digitalWrite(Voie_3,LOW);
    		tone(Voie_4,440,4000);
    		Timer1.detachInterrupt();
   		ticks = 0;
   		change = 0;
  	}
  	else
  	{
  		ticks++; 
  		digitalWrite(Voie_3,HIGH);
  	} 
}

void loop() // debut de la fonction loop()
{ 

	// --- ici instructions à exécuter par le programme principal ---

	// acquisition conversion analogique-numerique (CAN) sur la voie analogique
	// affiche valeur numerique entière ou à virgule au format décimal

	if (!change)
	{
  		set_sleep_mode(SLEEP_MODE_PWR_SAVE);
  		sleep_mode();
	}

	int mesure_a=analogRead(Voie_0);
	int mesure_b=analogRead(Voie_1);
	int mesure_c=analogRead(Voie_2);
	delay(1000);

	int mesure_a2=analogRead(Voie_0);
	int mesure_b2=analogRead(Voie_1);
	int mesure_c2=analogRead(Voie_2);

	Serial.print("a2 =");
	Serial.println(mesure_a - mesure_a2);
	Serial.print("b2=");
	Serial.println(mesure_b - mesure_b2);
	Serial.print("c2=");
	Serial.println(mesure_c - mesure_c2);

	Serial.println("interruption");
	delay(500);

	if ((change == 0) && (abs(mesure_a - mesure_a2) > 25) || (abs(mesure_b - mesure_b2) > 25) || (abs(mesure_c - mesure_c2) > 25))
    	{
      		change = 1;
      		Serial.print("change a 1");
       		sleep_disable();
       		wdt_disable();
    	}     
	if (change)
	{
  		// affiche valeur numerique entière ou à virgule au format décimal
		if ((abs(mesure_a - mesure_a2) > 100) || (abs(mesure_b - mesure_b2) > 100) || (abs(mesure_c - mesure_c2) > 100))
		{
  			//digitalWrite(led, HIGH); 
  			if (ticks == 0)
  			{
   				Serial.write("je suis passe");
  				Timer1.attachInterrupt(Comptetemps);
  			}  
		}
		else 
		{
 			// digitalWrite(led, LOW);
  			if (ticks != 0)
  			{
  				digitalWrite(Voie_3,LOW);
  				if (abs(mesure_a - mesure_a2) < 50) 
  				tone(Voie_4,750,500);
  			}
  		Serial.write("je suis passe2");

		}
	}
} 



